(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('codemirror'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-codemirror', ['exports', '@angular/core', 'codemirror', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['ng-codemirror'] = {}, global.ng.core, global.codemirror, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, codemirror, operators, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: codemirror.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CodeMirrorComponent = /** @class */ (function () {
        function CodeMirrorComponent(elementRef, ngZone, renderer, _differs, _ngZone) {
            this.elementRef = elementRef;
            this.ngZone = ngZone;
            this.renderer = renderer;
            this._differs = _differs;
            this._ngZone = _ngZone;
            this.autoMaxHeight = 0;
            this.codeChange = new core.EventEmitter();
            this.focusChange = new core.EventEmitter();
            this.codemirrorClassName = true;
        }
        /**
         * @return {?}
         */
        CodeMirrorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this._differ && this.options) {
                this._differ = this._differs.find(this.options).create();
            }
        };
        /**
         * @return {?}
         */
        CodeMirrorComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.elementRef.nativeElement.offsetWidth > 0) {
                this.initCodemirror();
                if (this.autoMaxHeight > 0) {
                    this.renderer.setStyle(this.elementRef.nativeElement, "maxHeight", this.autoMaxHeight + "px");
                }
            }
            else {
                this.ngZone.onStable
                    .asObservable()
                    .pipe(operators.filter((/**
                 * @return {?}
                 */
                function () {
                    return _this.elementRef.nativeElement.offsetWidth > 0;
                })), operators.take(1))
                    .subscribe((/**
                 * @return {?}
                 */
                function () {
                    _this.initCodemirror();
                }));
            }
        };
        /**
         * @param {?} simpleChanges
         * @return {?}
         */
        CodeMirrorComponent.prototype.ngOnChanges = /**
         * @param {?} simpleChanges
         * @return {?}
         */
        function (simpleChanges) {
            var _this = this;
            /** @type {?} */
            var optionsChange = simpleChanges.options;
            if (optionsChange && !optionsChange.firstChange) {
                /** @type {?} */
                var changes = this._differ.diff(this.options);
                if (changes) {
                    changes.forEachChangedItem((/**
                     * @param {?} option
                     * @return {?}
                     */
                    function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    }));
                    changes.forEachAddedItem((/**
                     * @param {?} option
                     * @return {?}
                     */
                    function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    }));
                    changes.forEachRemovedItem((/**
                     * @param {?} option
                     * @return {?}
                     */
                    function (option) {
                        return _this.setOptionIfChanged(option.key, option.currentValue);
                    }));
                }
            }
        };
        /**
         * @return {?}
         */
        CodeMirrorComponent.prototype.initCodemirror = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.ngZone.runOutsideAngular((/**
             * @return {?}
             */
            function () {
                if (!_this.options) {
                    throw new Error("options is required");
                }
                _this.editor = codemirror.fromTextArea(_this.textAreaRef.nativeElement, _this.options);
                _this.editor.setValue(_this.code ? _this.code : "");
                _this.editor.on("focus", (/**
                 * @return {?}
                 */
                function () {
                    return _this.ngZone.run((/**
                     * @return {?}
                     */
                    function () { return _this.focusChange.emit(true); }));
                }));
                _this.editor.on("blur", (/**
                 * @return {?}
                 */
                function () {
                    _this.ngZone.run((/**
                     * @return {?}
                     */
                    function () { return _this.focusChange.emit(false); }));
                    _this.editor.setCursor(0, null, { scroll: false });
                }));
                _this.editor.on("change", (/**
                 * @param {?} cm
                 * @param {?} change
                 * @return {?}
                 */
                function (cm, change) {
                    if (change.origin !== "setValue") {
                        _this.code = cm.getValue();
                        _this.codeChange.emit(_this.code);
                    }
                }));
                if (_this.autoMaxHeight > 0) {
                    _this.initMaxHeight();
                }
            }));
        };
        /**
         * @private
         * @return {?}
         */
        CodeMirrorComponent.prototype.initMaxHeight = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var codeWrapElement = (/** @type {?} */ (((/** @type {?} */ (this.elementRef
                .nativeElement))).querySelector(".CodeMirror-code")));
            this.applyEditorHeight(codeWrapElement);
            /** @type {?} */
            var codemirrorContentObserver = new MutationObserver((/**
             * @return {?}
             */
            function () {
                _this.applyEditorHeight(codeWrapElement);
            }));
            codemirrorContentObserver.observe(codeWrapElement, {
                childList: true,
            });
        };
        /**
         * @private
         * @param {?} code
         * @return {?}
         */
        CodeMirrorComponent.prototype.applyEditorHeight = /**
         * @private
         * @param {?} code
         * @return {?}
         */
        function (code) {
            if (code.offsetHeight >= this.autoMaxHeight) {
                /** @type {?} */
                var wrapHeight = (/** @type {?} */ (((/** @type {?} */ (this.elementRef
                    .nativeElement))).querySelector(".CodeMirror")));
                if (wrapHeight.offsetHeight >= this.autoMaxHeight) {
                    this.editor.setSize("100%", this.autoMaxHeight + "px");
                }
            }
            else {
                this.editor.setSize("100%", "auto");
            }
        };
        /**
         * @param {?} optionName
         * @param {?} newValue
         * @return {?}
         */
        CodeMirrorComponent.prototype.setOptionIfChanged = /**
         * @param {?} optionName
         * @param {?} newValue
         * @return {?}
         */
        function (optionName, newValue) {
            if (!this.editor) {
                return;
            }
            // cast to any to handle strictly typed option names
            // could possibly import settings strings available in the future
            this.editor.setOption((/** @type {?} */ (optionName)), newValue);
        };
        /**
         * @return {?}
         */
        CodeMirrorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () { };
        CodeMirrorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "ng-code-mirror, [ngCodeMirror]",
                        template: "<textarea #textAreaRef></textarea>",
                        preserveWhitespaces: false,
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    }] }
        ];
        /** @nocollapse */
        CodeMirrorComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.NgZone },
            { type: core.Renderer2 },
            { type: core.KeyValueDiffers },
            { type: core.NgZone }
        ]; };
        CodeMirrorComponent.propDecorators = {
            code: [{ type: core.Input }],
            autoMaxHeight: [{ type: core.Input }],
            options: [{ type: core.Input }],
            codeChange: [{ type: core.Output }],
            focusChange: [{ type: core.Output }],
            textAreaRef: [{ type: core.ViewChild, args: ["textAreaRef", { read: core.ElementRef, static: true },] }],
            codemirrorClassName: [{ type: core.HostBinding, args: ["class.ng-codemirror",] }]
        };
        return CodeMirrorComponent;
    }());
    if (false) {
        /** @type {?} */
        CodeMirrorComponent.prototype.code;
        /** @type {?} */
        CodeMirrorComponent.prototype.autoMaxHeight;
        /** @type {?} */
        CodeMirrorComponent.prototype.options;
        /** @type {?} */
        CodeMirrorComponent.prototype.codeChange;
        /** @type {?} */
        CodeMirrorComponent.prototype.focusChange;
        /** @type {?} */
        CodeMirrorComponent.prototype.textAreaRef;
        /** @type {?} */
        CodeMirrorComponent.prototype.codemirrorClassName;
        /** @type {?} */
        CodeMirrorComponent.prototype.editor;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype._differ;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype.elementRef;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype.ngZone;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype.renderer;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype._differs;
        /**
         * @type {?}
         * @private
         */
        CodeMirrorComponent.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: codemirror.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CodemirrorModule = /** @class */ (function () {
        function CodemirrorModule() {
        }
        CodemirrorModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [CodeMirrorComponent],
                        entryComponents: [CodeMirrorComponent],
                        exports: [CodeMirrorComponent]
                    },] }
        ];
        return CodemirrorModule;
    }());

    exports.CodeMirrorComponent = CodeMirrorComponent;
    exports.CodemirrorModule = CodemirrorModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-codemirror.umd.js.map
