import { OnInit, ElementRef, OnChanges, SimpleChanges, NgZone, EventEmitter, OnDestroy, AfterViewInit, Renderer2, KeyValueDiffers } from "@angular/core";
import * as codemirror from "codemirror";
export declare class CodeMirrorComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private elementRef;
    private ngZone;
    private renderer;
    private _differs;
    private _ngZone;
    code: string;
    autoMaxHeight: number;
    options: codemirror.EditorConfiguration;
    codeChange: EventEmitter<string>;
    focusChange: EventEmitter<boolean>;
    textAreaRef: ElementRef;
    codemirrorClassName: boolean;
    editor: codemirror.EditorFromTextArea;
    private _differ;
    constructor(elementRef: ElementRef, ngZone: NgZone, renderer: Renderer2, _differs: KeyValueDiffers, _ngZone: NgZone);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(simpleChanges: SimpleChanges): void;
    initCodemirror(): void;
    private initMaxHeight;
    private applyEditorHeight;
    setOptionIfChanged(optionName: string, newValue: any): void;
    ngOnDestroy(): void;
}
